<template>
    <h1>Top Rated</h1>
    <section class="movie-grid">
    <TopRatedCard v-for="movie in movies" :movie="movie"/>
    </section>
</template>

<script>
import apiMovie from '@/services/api.services'
import TopRatedCard from './TopRatedCard.vue';
import MovieModel from "@/models/Movie"

export default{
  components: { TopRatedCard },
    data(){
        return {
            movies:[],
        };

    },
    mounted(){
        this.getTopRated();
    },
    methods: {
        async getTopRated(){
            const {data} =await apiMovie.getTopRated();
            this.movies =await Promise.all(
                data.results.map((mov) => this.getPop(mov.id))
            );
        },
        async getPop(id){
            const { data } = await apiMovie.getMovie(id);
            const movieData = new MovieModel(data)
            return movieData;
        }
    },
    
};
</script>

<style >
.movie-grid{
    padding: 1rem;
    display: grid;
    grid-template-columns: repeat(4,minmax(200px,1fr));
    grid-auto-rows: 200px;
    gap: 1rem;
}
</style>

